#pragma once

#pragma warning(disable: 4786)
#define SILENT_PARSER		// Comment this line in console app to see the inner workings of Parse()

#include <string>
#include <map>
using namespace std;

struct CConfig {
	CConfig() {};
	~CConfig() {};

	enum ENUM_REPLIES {
		OK = 0,
		NO_NAME,
		NO_VALUE,
		NUM_REPLIES
	};

	// Parses a string
	ENUM_REPLIES Parse( char *psz );
	// Parses Quake style .CFG files
	void ParseCfg( char *File );
	// Parses Windows .INI files, ignores sections
	void ParseIni( char *File );
	// Parses CGI data from both GET and POST (not tested)
	void ParseCgi();

	inline string GetString( string &Name );
	inline int GetInt( string &Name );
	inline float GetFloat( string &Name );

	struct CVar {
		int Int;
		float Float;
		string String;
	} Latest;
	

protected:
	typedef map<string, CVar> MYMAP;
	MYMAP Variables;
	map<string, CVar>::iterator Iterator;
	CVar Variable;
	bool GetVarByName( string &Name );
};